/* tracker-turtle-reader.c generated by valac 0.52.4, the Vala compiler
 * generated from tracker-turtle-reader.vala, do not modify */

/*
 * Copyright (C) 2009, Nokia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include "tracker-sparql-query.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "libtracker-sparql/tracker-sparql.h"
#include "libtracker-data/tracker-data-query.h"
#include "libtracker-data/tracker-data-update.h"
#include "libtracker-common/tracker-date-time.h"
#include "libtracker-data/tracker-db-interface.h"

#define TRACKER_TURTLE_READER_TYPE_TOKEN_INFO (tracker_turtle_reader_token_info_get_type ())
typedef struct _TrackerTurtleReaderTokenInfo TrackerTurtleReaderTokenInfo;
typedef enum  {
	TRACKER_TURTLE_READER_STATE_INITIAL,
	TRACKER_TURTLE_READER_STATE_BOS,
	TRACKER_TURTLE_READER_STATE_SUBJECT,
	TRACKER_TURTLE_READER_STATE_PREDICATE,
	TRACKER_TURTLE_READER_STATE_OBJECT
} TrackerTurtleReaderState;

#define TRACKER_TURTLE_READER_TYPE_STATE (tracker_turtle_reader_state_get_type ())
enum  {
	TRACKER_TURTLE_READER_0_PROPERTY,
	TRACKER_TURTLE_READER_GRAPH_PROPERTY,
	TRACKER_TURTLE_READER_SUBJECT_PROPERTY,
	TRACKER_TURTLE_READER_PREDICATE_PROPERTY,
	TRACKER_TURTLE_READER_OBJECT_PROPERTY,
	TRACKER_TURTLE_READER_OBJECT_IS_URI_PROPERTY,
	TRACKER_TURTLE_READER_NUM_PROPERTIES
};
static GParamSpec* tracker_turtle_reader_properties[TRACKER_TURTLE_READER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_mapped_file_unref0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_unref (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TrackerTurtleReaderTokenInfo {
	TrackerSparqlTokenType type;
	TrackerSourceLocation begin;
	TrackerSourceLocation end;
};

struct _TrackerTurtleReaderPrivate {
	TrackerSparqlScanner* scanner;
	TrackerTurtleReaderTokenInfo* tokens;
	gint tokens_length1;
	gint _tokens_size_;
	gint index;
	gint size;
	TrackerTurtleReaderState state;
	gchar* _graph;
	gchar* _subject;
	gchar* _predicate;
	gchar* _object;
	gboolean _object_is_uri;
	GHashTable* prefix_map;
	GQueue* subject_stack;
	GQueue* predicate_stack;
	gint bnodeid;
	guchar* base_uuid;
	gint base_uuid_length1;
	gint _base_uuid_size_;
	GMappedFile* mapped_file;
	guchar* buffer;
	gint buffer_length1;
	gint _buffer_size_;
};

static gint TrackerTurtleReader_private_offset;
static gpointer tracker_turtle_reader_parent_class = NULL;

static GType tracker_turtle_reader_token_info_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static TrackerTurtleReaderTokenInfo* tracker_turtle_reader_token_info_dup (const TrackerTurtleReaderTokenInfo* self);
static void tracker_turtle_reader_token_info_free (TrackerTurtleReaderTokenInfo* self);
static GType tracker_turtle_reader_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
#define TRACKER_TURTLE_READER_BUFFER_SIZE 32
#define TRACKER_TURTLE_READER_MAX_ONTOLOGY_SIZE ((2 * 1024) * 1024)
static void _g_free0_ (gpointer var);
static inline void _g_queue_free__g_free0_ (GQueue* self);
static gchar* tracker_turtle_reader_generate_bnodeid (TrackerTurtleReader* self,
                                               const gchar* user_bnodeid);
static inline gboolean tracker_turtle_reader_next_token (TrackerTurtleReader* self,
                                           GError** error);
static inline TrackerSparqlTokenType tracker_turtle_reader_current (TrackerTurtleReader* self);
static inline gboolean tracker_turtle_reader_accept (TrackerTurtleReader* self,
                                       TrackerSparqlTokenType type,
                                       GError** error);
static GError* tracker_turtle_reader_get_error (TrackerTurtleReader* self,
                                         const gchar* msg);
static gboolean tracker_turtle_reader_expect (TrackerTurtleReader* self,
                                       TrackerSparqlTokenType type,
                                       GError** error);
static gchar* tracker_turtle_reader_get_last_string (TrackerTurtleReader* self,
                                              gint strip);
static gchar* tracker_turtle_reader_resolve_prefixed_name (TrackerTurtleReader* self,
                                                    const gchar* prefix,
                                                    const gchar* local_name,
                                                    GError** error);
static void tracker_turtle_reader_set_subject (TrackerTurtleReader* self,
                                        const gchar* value);
static void tracker_turtle_reader_set_predicate (TrackerTurtleReader* self,
                                          const gchar* value);
static void tracker_turtle_reader_set_object (TrackerTurtleReader* self,
                                       const gchar* value);
static void tracker_turtle_reader_set_object_is_uri (TrackerTurtleReader* self,
                                              gboolean value);
static void tracker_turtle_reader_set_graph (TrackerTurtleReader* self,
                                      const gchar* value);
static void tracker_turtle_reader_finalize (GObject * obj);
static GType tracker_turtle_reader_get_type_once (void);
static void _vala_tracker_turtle_reader_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_tracker_turtle_reader_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
tracker_turtle_reader_get_instance_private (TrackerTurtleReader* self)
{
	return G_STRUCT_MEMBER_P (self, TrackerTurtleReader_private_offset);
}

static GType
tracker_turtle_reader_state_get_type_once (void)
{
	static const GEnumValue values[] = {{TRACKER_TURTLE_READER_STATE_INITIAL, "TRACKER_TURTLE_READER_STATE_INITIAL", "initial"}, {TRACKER_TURTLE_READER_STATE_BOS, "TRACKER_TURTLE_READER_STATE_BOS", "bos"}, {TRACKER_TURTLE_READER_STATE_SUBJECT, "TRACKER_TURTLE_READER_STATE_SUBJECT", "subject"}, {TRACKER_TURTLE_READER_STATE_PREDICATE, "TRACKER_TURTLE_READER_STATE_PREDICATE", "predicate"}, {TRACKER_TURTLE_READER_STATE_OBJECT, "TRACKER_TURTLE_READER_STATE_OBJECT", "object"}, {0, NULL, NULL}};
	GType tracker_turtle_reader_state_type_id;
	tracker_turtle_reader_state_type_id = g_enum_register_static ("TrackerTurtleReaderState", values);
	return tracker_turtle_reader_state_type_id;
}

static GType
tracker_turtle_reader_state_get_type (void)
{
	static volatile gsize tracker_turtle_reader_state_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_turtle_reader_state_type_id__volatile)) {
		GType tracker_turtle_reader_state_type_id;
		tracker_turtle_reader_state_type_id = tracker_turtle_reader_state_get_type_once ();
		g_once_init_leave (&tracker_turtle_reader_state_type_id__volatile, tracker_turtle_reader_state_type_id);
	}
	return tracker_turtle_reader_state_type_id__volatile;
}

static void
_g_free0_ (gpointer var)
{
#line 61 "../src/libtracker-data/tracker-turtle-reader.vala"
	var = (g_free (var), NULL);
#line 180 "tracker-turtle-reader.c"
}

static inline void
_g_queue_free__g_free0_ (GQueue* self)
{
#line 61 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_free0_);
#line 188 "tracker-turtle-reader.c"
}

TrackerTurtleReader*
tracker_turtle_reader_construct (GType object_type,
                                 GFile* file,
                                 GError** error)
{
	TrackerTurtleReader * self = NULL;
	guchar* _tmp18_;
	guchar* _tmp19_;
	gint _tmp19__length1;
	TrackerTurtleReaderTokenInfo* _tmp20_;
	GHashFunc _tmp21_;
	GEqualFunc _tmp22_;
	GDestroyNotify _tmp23_;
	GDestroyNotify _tmp24_;
	GHashTable* _tmp25_;
	GQueue* _tmp26_;
	GQueue* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 71 "../src/libtracker-data/tracker-turtle-reader.vala"
	self = (TrackerTurtleReader*) g_object_new (object_type, NULL);
#line 72 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (g_file_is_native (file)) {
#line 215 "tracker-turtle-reader.c"
		GMappedFile* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GMappedFile* _tmp3_;
		GMappedFile* _tmp4_;
		GMappedFile* _tmp5_;
		GMappedFile* _tmp6_;
		gchar* _tmp7_;
		GMappedFile* _tmp8_;
		TrackerSparqlScanner* _tmp9_;
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp1_ = g_file_get_path (file);
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp2_ = _tmp1_;
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp3_ = g_mapped_file_new (_tmp2_, FALSE, &_inner_error0_);
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp4_ = _tmp3_;
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (_tmp2_);
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = _tmp4_;
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (self);
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
			return NULL;
#line 246 "tracker-turtle-reader.c"
		}
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp5_ = _tmp0_;
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = NULL;
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_mapped_file_unref0 (self->priv->mapped_file);
#line 73 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->mapped_file = _tmp5_;
#line 74 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp6_ = self->priv->mapped_file;
#line 74 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp7_ = g_mapped_file_get_contents (_tmp6_);
#line 74 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp8_ = self->priv->mapped_file;
#line 74 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp9_ = tracker_sparql_scanner_new (_tmp7_, g_mapped_file_get_length (_tmp8_));
#line 74 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_object_unref0 (self->priv->scanner);
#line 74 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->scanner = _tmp9_;
#line 72 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_mapped_file_unref0 (_tmp0_);
#line 270 "tracker-turtle-reader.c"
	} else {
		gsize len = 0UL;
		GFileInputStream* istream = NULL;
		GFileInputStream* _tmp10_;
		guchar* _tmp11_;
		GFileInputStream* _tmp12_;
		guchar* _tmp13_;
		gint _tmp13__length1;
		gsize _tmp14_ = 0UL;
		guchar* _tmp16_;
		gint _tmp16__length1;
		TrackerSparqlScanner* _tmp17_;
#line 77 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp10_ = g_file_read (file, NULL, &_inner_error0_);
#line 77 "../src/libtracker-data/tracker-turtle-reader.vala"
		istream = _tmp10_;
#line 77 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 77 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (self);
#line 77 "../src/libtracker-data/tracker-turtle-reader.vala"
			return NULL;
#line 295 "tracker-turtle-reader.c"
		}
#line 78 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp11_ = g_new0 (guchar, TRACKER_TURTLE_READER_MAX_ONTOLOGY_SIZE);
#line 78 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->buffer = (g_free (self->priv->buffer), NULL);
#line 78 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->buffer = _tmp11_;
#line 78 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->buffer_length1 = TRACKER_TURTLE_READER_MAX_ONTOLOGY_SIZE;
#line 78 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->_buffer_size_ = self->priv->buffer_length1;
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp12_ = istream;
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp13_ = self->priv->buffer;
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp13__length1 = self->priv->buffer_length1;
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_input_stream_read_all ((GInputStream*) _tmp12_, _tmp13_, (gsize) _tmp13__length1, &_tmp14_, NULL, &_inner_error0_);
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
		len = _tmp14_;
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (istream);
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (self);
#line 79 "../src/libtracker-data/tracker-turtle-reader.vala"
			return NULL;
#line 327 "tracker-turtle-reader.c"
		}
#line 82 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (len == ((gsize) TRACKER_TURTLE_READER_MAX_ONTOLOGY_SIZE)) {
#line 331 "tracker-turtle-reader.c"
			GError* _tmp15_;
#line 83 "../src/libtracker-data/tracker-turtle-reader.vala"
			_tmp15_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Ontology file too large");
#line 83 "../src/libtracker-data/tracker-turtle-reader.vala"
			_inner_error0_ = _tmp15_;
#line 83 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 83 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (istream);
#line 83 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (self);
#line 83 "../src/libtracker-data/tracker-turtle-reader.vala"
			return NULL;
#line 345 "tracker-turtle-reader.c"
		}
#line 85 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp16_ = self->priv->buffer;
#line 85 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp16__length1 = self->priv->buffer_length1;
#line 85 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp17_ = tracker_sparql_scanner_new (_tmp16_, len);
#line 85 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_object_unref0 (self->priv->scanner);
#line 85 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->scanner = _tmp17_;
#line 72 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_object_unref0 (istream);
#line 359 "tracker-turtle-reader.c"
	}
#line 88 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp18_ = g_new0 (guchar, 16);
#line 88 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->base_uuid = (g_free (self->priv->base_uuid), NULL);
#line 88 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->base_uuid = _tmp18_;
#line 88 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->base_uuid_length1 = 16;
#line 88 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->_base_uuid_size_ = self->priv->base_uuid_length1;
#line 89 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp19_ = self->priv->base_uuid;
#line 89 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp19__length1 = self->priv->base_uuid_length1;
#line 89 "../src/libtracker-data/tracker-turtle-reader.vala"
	uuid_generate (_tmp19_);
#line 91 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp20_ = g_new0 (TrackerTurtleReaderTokenInfo, TRACKER_TURTLE_READER_BUFFER_SIZE);
#line 91 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->tokens = (g_free (self->priv->tokens), NULL);
#line 91 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->tokens = _tmp20_;
#line 91 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->tokens_length1 = TRACKER_TURTLE_READER_BUFFER_SIZE;
#line 91 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->_tokens_size_ = self->priv->tokens_length1;
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp21_ = g_str_hash;
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp22_ = g_str_equal;
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp23_ = g_free;
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp24_ = g_free;
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp25_ = g_hash_table_new_full (_tmp21_, _tmp22_, _tmp23_, _tmp24_);
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_hash_table_unref0 (self->priv->prefix_map);
#line 92 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->prefix_map = _tmp25_;
#line 93 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp26_ = g_queue_new ();
#line 93 "../src/libtracker-data/tracker-turtle-reader.vala"
	(self->priv->subject_stack == NULL) ? NULL : (self->priv->subject_stack = (_g_queue_free__g_free0_ (self->priv->subject_stack), NULL));
#line 93 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->subject_stack = _tmp26_;
#line 94 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp27_ = g_queue_new ();
#line 94 "../src/libtracker-data/tracker-turtle-reader.vala"
	(self->priv->predicate_stack == NULL) ? NULL : (self->priv->predicate_stack = (_g_queue_free__g_free0_ (self->priv->predicate_stack), NULL));
#line 94 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->predicate_stack = _tmp27_;
#line 71 "../src/libtracker-data/tracker-turtle-reader.vala"
	return self;
#line 415 "tracker-turtle-reader.c"
}

TrackerTurtleReader*
tracker_turtle_reader_new (GFile* file,
                           GError** error)
{
#line 71 "../src/libtracker-data/tracker-turtle-reader.vala"
	return tracker_turtle_reader_construct (TRACKER_TYPE_TURTLE_READER, file, error);
#line 424 "tracker-turtle-reader.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 447 "tracker-turtle-reader.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 456 "tracker-turtle-reader.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 475 "tracker-turtle-reader.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 479 "tracker-turtle-reader.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 485 "tracker-turtle-reader.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 495 "tracker-turtle-reader.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 503 "tracker-turtle-reader.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 507 "tracker-turtle-reader.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 513 "tracker-turtle-reader.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 523 "tracker-turtle-reader.c"
}

static gchar*
tracker_turtle_reader_generate_bnodeid (TrackerTurtleReader* self,
                                        const gchar* user_bnodeid)
{
	gchar* result = NULL;
#line 97 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (user_bnodeid == NULL) {
#line 535 "tracker-turtle-reader.c"
		gint _tmp0_;
		gchar* _tmp1_;
#line 100 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->bnodeid = self->priv->bnodeid + 1;
#line 100 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = self->priv->bnodeid;
#line 100 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp1_ = g_strdup_printf (":%d", _tmp0_);
#line 100 "../src/libtracker-data/tracker-turtle-reader.vala"
		result = _tmp1_;
#line 100 "../src/libtracker-data/tracker-turtle-reader.vala"
		return result;
#line 548 "tracker-turtle-reader.c"
	} else {
		GChecksum* checksum = NULL;
		GChecksum* _tmp2_;
		GChecksum* _tmp3_;
		guchar* _tmp4_;
		gint _tmp4__length1;
		GChecksum* _tmp5_;
		gchar* sha1 = NULL;
		GChecksum* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 102 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp2_ = g_checksum_new (G_CHECKSUM_SHA1);
#line 102 "../src/libtracker-data/tracker-turtle-reader.vala"
		checksum = _tmp2_;
#line 104 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp3_ = checksum;
#line 104 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp4_ = self->priv->base_uuid;
#line 104 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp4__length1 = self->priv->base_uuid_length1;
#line 104 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_checksum_update (_tmp3_, _tmp4_, (gsize) 16);
#line 106 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp5_ = checksum;
#line 106 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_checksum_update (_tmp5_, (guchar*) user_bnodeid, (gsize) -1);
#line 108 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp6_ = checksum;
#line 108 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp7_ = g_checksum_get_string (_tmp6_);
#line 108 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 108 "../src/libtracker-data/tracker-turtle-reader.vala"
		sha1 = _tmp8_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp9_ = sha1;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp10_ = sha1;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp11_ = string_substring (_tmp10_, (glong) 8, (glong) -1);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp12_ = _tmp11_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp13_ = sha1;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp14_ = string_substring (_tmp13_, (glong) 12, (glong) -1);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp15_ = _tmp14_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp16_ = sha1;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp17_ = string_substring (_tmp16_, (glong) 16, (glong) -1);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp18_ = _tmp17_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp19_ = sha1;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp20_ = string_substring (_tmp19_, (glong) 20, (glong) -1);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp21_ = _tmp20_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp22_ = g_strdup_printf ("urn:uuid:%.8s-%.4s-%.4s-%.4s-%.12s", _tmp9_, _tmp12_, _tmp15_, _tmp18_, _tmp21_);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp23_ = _tmp22_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (_tmp21_);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (_tmp18_);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (_tmp15_);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (_tmp12_);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		result = _tmp23_;
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (sha1);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_checksum_free0 (checksum);
#line 111 "../src/libtracker-data/tracker-turtle-reader.vala"
		return result;
#line 645 "tracker-turtle-reader.c"
	}
}

static inline gboolean
tracker_turtle_reader_next_token (TrackerTurtleReader* self,
                                  GError** error)
{
	gint _tmp0_;
	TrackerTurtleReaderTokenInfo* _tmp13_;
	gint _tmp13__length1;
	TrackerTurtleReaderTokenInfo _tmp14_;
	TrackerSparqlTokenType _tmp15_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 116 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->index = (self->priv->index + 1) % TRACKER_TURTLE_READER_BUFFER_SIZE;
#line 118 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->size;
#line 118 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->size = _tmp0_ - 1;
#line 119 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (self->priv->size <= 0) {
#line 670 "tracker-turtle-reader.c"
		TrackerSourceLocation begin = {0};
		TrackerSourceLocation end = {0};
		TrackerSparqlTokenType type = 0;
		TrackerSparqlScanner* _tmp1_;
		TrackerSourceLocation _tmp2_ = {0};
		TrackerSourceLocation _tmp3_ = {0};
		TrackerSparqlTokenType _tmp4_;
		TrackerTurtleReaderTokenInfo* _tmp7_;
		gint _tmp7__length1;
		TrackerSparqlTokenType _tmp8_;
		TrackerTurtleReaderTokenInfo* _tmp9_;
		gint _tmp9__length1;
		TrackerSourceLocation _tmp10_;
		TrackerTurtleReaderTokenInfo* _tmp11_;
		gint _tmp11__length1;
		TrackerSourceLocation _tmp12_;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp1_ = self->priv->scanner;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp4_ = tracker_sparql_scanner_read_token (_tmp1_, &_tmp2_, &_tmp3_, &_inner_error0_);
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
		begin = _tmp2_;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
		end = _tmp3_;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
		type = _tmp4_;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 701 "tracker-turtle-reader.c"
				gboolean _tmp5_ = FALSE;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
				return _tmp5_;
#line 707 "tracker-turtle-reader.c"
			} else {
				gboolean _tmp6_ = FALSE;
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_clear_error (&_inner_error0_);
#line 121 "../src/libtracker-data/tracker-turtle-reader.vala"
				return _tmp6_;
#line 716 "tracker-turtle-reader.c"
			}
		}
#line 122 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp7_ = self->priv->tokens;
#line 122 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp7__length1 = self->priv->tokens_length1;
#line 122 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp8_ = type;
#line 122 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp7_[self->priv->index].type = _tmp8_;
#line 123 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp9_ = self->priv->tokens;
#line 123 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp9__length1 = self->priv->tokens_length1;
#line 123 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp10_ = begin;
#line 123 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp9_[self->priv->index].begin = _tmp10_;
#line 124 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp11_ = self->priv->tokens;
#line 124 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp11__length1 = self->priv->tokens_length1;
#line 124 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp12_ = end;
#line 124 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp11_[self->priv->index].end = _tmp12_;
#line 125 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->size = 1;
#line 745 "tracker-turtle-reader.c"
	}
#line 127 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp13_ = self->priv->tokens;
#line 127 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp13__length1 = self->priv->tokens_length1;
#line 127 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp14_ = _tmp13_[self->priv->index];
#line 127 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp15_ = _tmp14_.type;
#line 127 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp15_ != TRACKER_SPARQL_TOKEN_TYPE_EOF;
#line 127 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 759 "tracker-turtle-reader.c"
}

static inline TrackerSparqlTokenType
tracker_turtle_reader_current (TrackerTurtleReader* self)
{
	TrackerTurtleReaderTokenInfo* _tmp0_;
	gint _tmp0__length1;
	TrackerTurtleReaderTokenInfo _tmp1_;
	TrackerSparqlTokenType _tmp2_;
	TrackerSparqlTokenType result = 0;
#line 130 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 131 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->tokens;
#line 131 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0__length1 = self->priv->tokens_length1;
#line 131 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp1_ = _tmp0_[self->priv->index];
#line 131 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp2_ = _tmp1_.type;
#line 131 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp2_;
#line 131 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 784 "tracker-turtle-reader.c"
}

static inline gboolean
tracker_turtle_reader_accept (TrackerTurtleReader* self,
                              TrackerSparqlTokenType type,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 134 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 135 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (tracker_turtle_reader_current (self) == type) {
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_turtle_reader_next_token (self, &_inner_error0_);
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 804 "tracker-turtle-reader.c"
				gboolean _tmp0_ = FALSE;
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
				return _tmp0_;
#line 810 "tracker-turtle-reader.c"
			} else {
				gboolean _tmp1_ = FALSE;
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_clear_error (&_inner_error0_);
#line 136 "../src/libtracker-data/tracker-turtle-reader.vala"
				return _tmp1_;
#line 819 "tracker-turtle-reader.c"
			}
		}
#line 137 "../src/libtracker-data/tracker-turtle-reader.vala"
		result = TRUE;
#line 137 "../src/libtracker-data/tracker-turtle-reader.vala"
		return result;
#line 826 "tracker-turtle-reader.c"
	}
#line 139 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = FALSE;
#line 139 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 832 "tracker-turtle-reader.c"
}

static GError*
tracker_turtle_reader_get_error (TrackerTurtleReader* self,
                                 const gchar* msg)
{
	TrackerTurtleReaderTokenInfo* _tmp0_;
	gint _tmp0__length1;
	TrackerTurtleReaderTokenInfo _tmp1_;
	TrackerSourceLocation _tmp2_;
	TrackerTurtleReaderTokenInfo* _tmp3_;
	gint _tmp3__length1;
	TrackerTurtleReaderTokenInfo _tmp4_;
	TrackerSourceLocation _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GError* result = NULL;
#line 142 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (msg != NULL, NULL);
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->tokens;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0__length1 = self->priv->tokens_length1;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp1_ = _tmp0_[self->priv->index];
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp2_ = _tmp1_.begin;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp3_ = self->priv->tokens;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp3__length1 = self->priv->tokens_length1;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp4_ = _tmp3_[self->priv->index];
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp5_ = _tmp4_.begin;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp6_ = g_strdup_printf ("%d.%d: syntax error, %s", _tmp2_.line, _tmp5_.column, msg);
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp7_ = _tmp6_;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp8_ = g_error_new_literal (TRACKER_SPARQL_ERROR, TRACKER_SPARQL_ERROR_PARSE, _tmp7_);
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp9_ = _tmp8_;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (_tmp7_);
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp9_;
#line 143 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 886 "tracker-turtle-reader.c"
}

static gboolean
tracker_turtle_reader_expect (TrackerTurtleReader* self,
                              TrackerSparqlTokenType type,
                              GError** error)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 146 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = tracker_turtle_reader_accept (self, type, &_inner_error0_);
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 910 "tracker-turtle-reader.c"
			gboolean _tmp1_ = FALSE;
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
			return _tmp1_;
#line 916 "tracker-turtle-reader.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_clear_error (&_inner_error0_);
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
			return _tmp2_;
#line 925 "tracker-turtle-reader.c"
		}
	}
#line 147 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (_tmp0_) {
#line 148 "../src/libtracker-data/tracker-turtle-reader.vala"
		result = TRUE;
#line 148 "../src/libtracker-data/tracker-turtle-reader.vala"
		return result;
#line 934 "tracker-turtle-reader.c"
	}
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp3_ = tracker_sparql_token_type_to_string (type);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp4_ = g_strdup_printf ("expected %s", _tmp3_);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp5_ = _tmp4_;
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp6_ = tracker_turtle_reader_get_error (self, _tmp5_);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp7_ = _tmp6_;
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (_tmp5_);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	_inner_error0_ = _tmp7_;
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 952 "tracker-turtle-reader.c"
		gboolean _tmp8_ = FALSE;
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_propagate_error (error, _inner_error0_);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
		return _tmp8_;
#line 958 "tracker-turtle-reader.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../src/libtracker-data/tracker-turtle-reader.vala"
		return _tmp9_;
#line 967 "tracker-turtle-reader.c"
	}
}

static gchar*
tracker_turtle_reader_get_last_string (TrackerTurtleReader* self,
                                       gint strip)
{
	gint last_index = 0;
	TrackerTurtleReaderTokenInfo* _tmp0_;
	gint _tmp0__length1;
	TrackerTurtleReaderTokenInfo _tmp1_;
	TrackerSourceLocation _tmp2_;
	gchar* _tmp3_;
	TrackerTurtleReaderTokenInfo* _tmp4_;
	gint _tmp4__length1;
	TrackerTurtleReaderTokenInfo _tmp5_;
	TrackerSourceLocation _tmp6_;
	gchar* _tmp7_;
	TrackerTurtleReaderTokenInfo* _tmp8_;
	gint _tmp8__length1;
	TrackerTurtleReaderTokenInfo _tmp9_;
	TrackerSourceLocation _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result = NULL;
#line 154 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 155 "../src/libtracker-data/tracker-turtle-reader.vala"
	last_index = ((self->priv->index + TRACKER_TURTLE_READER_BUFFER_SIZE) - 1) % TRACKER_TURTLE_READER_BUFFER_SIZE;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->tokens;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0__length1 = self->priv->tokens_length1;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp1_ = _tmp0_[last_index];
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp2_ = _tmp1_.begin;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp3_ = _tmp2_.pos;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp4_ = self->priv->tokens;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp4__length1 = self->priv->tokens_length1;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp5_ = _tmp4_[last_index];
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp6_ = _tmp5_.end;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp7_ = _tmp6_.pos;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp8_ = self->priv->tokens;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp8__length1 = self->priv->tokens_length1;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp9_ = _tmp8_[last_index];
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp10_ = _tmp9_.begin;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp11_ = _tmp10_.pos;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp12_ = string_substring ((const gchar*) (_tmp3_ + strip), (glong) 0, (glong) ((gint) ((_tmp7_ - _tmp11_) - (2 * strip))));
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp12_;
#line 156 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 1033 "tracker-turtle-reader.c"
}

static gchar*
tracker_turtle_reader_resolve_prefixed_name (TrackerTurtleReader* self,
                                             const gchar* prefix,
                                             const gchar* local_name,
                                             GError** error)
{
	gchar* ns = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 159 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 159 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 159 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (local_name != NULL, NULL);
#line 160 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->prefix_map;
#line 160 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, prefix);
#line 160 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
#line 160 "../src/libtracker-data/tracker-turtle-reader.vala"
	ns = _tmp2_;
#line 161 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp3_ = ns;
#line 161 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (_tmp3_ == NULL) {
#line 1069 "tracker-turtle-reader.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp4_ = g_strdup_printf ("use of undefined prefix `%s'", prefix);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp5_ = _tmp4_;
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp6_ = tracker_turtle_reader_get_error (self, _tmp5_);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp7_ = _tmp6_;
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (_tmp5_);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		_inner_error0_ = _tmp7_;
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_free0 (ns);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			return NULL;
#line 1094 "tracker-turtle-reader.c"
		} else {
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_free0 (ns);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_clear_error (&_inner_error0_);
#line 162 "../src/libtracker-data/tracker-turtle-reader.vala"
			return NULL;
#line 1104 "tracker-turtle-reader.c"
		}
	}
#line 164 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp8_ = ns;
#line 164 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp9_ = g_strconcat (_tmp8_, local_name, NULL);
#line 164 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp9_;
#line 164 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (ns);
#line 164 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 1117 "tracker-turtle-reader.c"
}

gboolean
tracker_turtle_reader_next (TrackerTurtleReader* self,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 167 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 168 "../src/libtracker-data/tracker-turtle-reader.vala"
	while (TRUE) {
#line 1130 "tracker-turtle-reader.c"
		TrackerTurtleReaderState _tmp0_;
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = self->priv->state;
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
		switch (_tmp0_) {
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
			case TRACKER_TURTLE_READER_STATE_INITIAL:
#line 1138 "tracker-turtle-reader.c"
			{
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
				tracker_turtle_reader_next_token (self, &_inner_error0_);
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1146 "tracker-turtle-reader.c"
						gboolean _tmp1_ = FALSE;
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_propagate_error (error, _inner_error0_);
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp1_;
#line 1152 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp2_ = FALSE;
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_clear_error (&_inner_error0_);
#line 171 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp2_;
#line 1161 "tracker-turtle-reader.c"
					}
				}
#line 172 "../src/libtracker-data/tracker-turtle-reader.vala"
				self->priv->state = TRACKER_TURTLE_READER_STATE_BOS;
#line 173 "../src/libtracker-data/tracker-turtle-reader.vala"
				continue;
#line 1168 "tracker-turtle-reader.c"
			}
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
			case TRACKER_TURTLE_READER_STATE_BOS:
#line 1172 "tracker-turtle-reader.c"
			{
				gboolean _tmp3_ = FALSE;
				gboolean _tmp30_ = FALSE;
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp3_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_ATPREFIX, &_inner_error0_);
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1182 "tracker-turtle-reader.c"
						gboolean _tmp4_ = FALSE;
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_propagate_error (error, _inner_error0_);
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp4_;
#line 1188 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp5_ = FALSE;
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_clear_error (&_inner_error0_);
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp5_;
#line 1197 "tracker-turtle-reader.c"
					}
				}
#line 176 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_tmp3_) {
#line 1202 "tracker-turtle-reader.c"
					gchar* ns = NULL;
					gchar* _tmp6_;
					gboolean _tmp7_ = FALSE;
					gchar* uri = NULL;
					gchar* _tmp15_;
					GHashTable* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 177 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp6_ = g_strdup ("");
#line 177 "../src/libtracker-data/tracker-turtle-reader.vala"
					ns = _tmp6_;
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp7_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_PN_PREFIX, &_inner_error0_);
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1223 "tracker-turtle-reader.c"
							gboolean _tmp8_ = FALSE;
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp8_;
#line 1231 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp9_ = FALSE;
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp9_;
#line 1242 "tracker-turtle-reader.c"
						}
					}
#line 178 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_tmp7_) {
#line 1247 "tracker-turtle-reader.c"
						gchar* _tmp10_;
#line 179 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp10_ = tracker_turtle_reader_get_last_string (self, 0);
#line 179 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (ns);
#line 179 "../src/libtracker-data/tracker-turtle-reader.vala"
						ns = _tmp10_;
#line 1255 "tracker-turtle-reader.c"
					}
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1263 "tracker-turtle-reader.c"
							gboolean _tmp11_ = FALSE;
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp11_;
#line 1271 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp12_ = FALSE;
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 181 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp12_;
#line 1282 "tracker-turtle-reader.c"
						}
					}
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1291 "tracker-turtle-reader.c"
							gboolean _tmp13_ = FALSE;
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp13_;
#line 1299 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp14_ = FALSE;
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 182 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp14_;
#line 1310 "tracker-turtle-reader.c"
						}
					}
#line 183 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp15_ = tracker_turtle_reader_get_last_string (self, 1);
#line 183 "../src/libtracker-data/tracker-turtle-reader.vala"
					uri = _tmp15_;
#line 184 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp16_ = self->priv->prefix_map;
#line 184 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp17_ = ns;
#line 184 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp18_ = g_strdup (_tmp17_);
#line 184 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp19_ = uri;
#line 184 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 184 "../src/libtracker-data/tracker-turtle-reader.vala"
					g_hash_table_insert (_tmp16_, _tmp18_, _tmp20_);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_DOT, &_inner_error0_);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1335 "tracker-turtle-reader.c"
							gboolean _tmp21_ = FALSE;
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (uri);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp21_;
#line 1345 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp22_ = FALSE;
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (uri);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (ns);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 185 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp22_;
#line 1358 "tracker-turtle-reader.c"
						}
					}
#line 186 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_free0 (uri);
#line 186 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_free0 (ns);
#line 186 "../src/libtracker-data/tracker-turtle-reader.vala"
					continue;
#line 1367 "tracker-turtle-reader.c"
				} else {
					gboolean _tmp23_ = FALSE;
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp23_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_ATBASE, &_inner_error0_);
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1376 "tracker-turtle-reader.c"
							gboolean _tmp24_ = FALSE;
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp24_;
#line 1382 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp25_ = FALSE;
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp25_;
#line 1391 "tracker-turtle-reader.c"
						}
					}
#line 187 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_tmp23_) {
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1402 "tracker-turtle-reader.c"
								gboolean _tmp26_ = FALSE;
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp26_;
#line 1408 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp27_ = FALSE;
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 188 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp27_;
#line 1417 "tracker-turtle-reader.c"
							}
						}
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_DOT, &_inner_error0_);
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1426 "tracker-turtle-reader.c"
								gboolean _tmp28_ = FALSE;
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp28_;
#line 1432 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp29_ = FALSE;
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 189 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp29_;
#line 1441 "tracker-turtle-reader.c"
							}
						}
#line 190 "../src/libtracker-data/tracker-turtle-reader.vala"
						continue;
#line 1446 "tracker-turtle-reader.c"
					} else {
#line 191 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (tracker_turtle_reader_current (self) == TRACKER_SPARQL_TOKEN_TYPE_EOF) {
#line 192 "../src/libtracker-data/tracker-turtle-reader.vala"
							result = FALSE;
#line 192 "../src/libtracker-data/tracker-turtle-reader.vala"
							return result;
#line 1454 "tracker-turtle-reader.c"
						}
					}
				}
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp30_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1464 "tracker-turtle-reader.c"
						gboolean _tmp31_ = FALSE;
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_propagate_error (error, _inner_error0_);
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp31_;
#line 1470 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp32_ = FALSE;
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_clear_error (&_inner_error0_);
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp32_;
#line 1479 "tracker-turtle-reader.c"
					}
				}
#line 195 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_tmp30_) {
#line 1484 "tracker-turtle-reader.c"
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 196 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp33_ = tracker_turtle_reader_get_last_string (self, 1);
#line 196 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp34_ = _tmp33_;
#line 196 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_set_subject (self, _tmp34_);
#line 196 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_free0 (_tmp34_);
#line 197 "../src/libtracker-data/tracker-turtle-reader.vala"
					self->priv->state = TRACKER_TURTLE_READER_STATE_SUBJECT;
#line 198 "../src/libtracker-data/tracker-turtle-reader.vala"
					continue;
#line 1499 "tracker-turtle-reader.c"
				} else {
					gboolean _tmp35_ = FALSE;
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp35_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_PN_PREFIX, &_inner_error0_);
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1508 "tracker-turtle-reader.c"
							gboolean _tmp36_ = FALSE;
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp36_;
#line 1514 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp37_ = FALSE;
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp37_;
#line 1523 "tracker-turtle-reader.c"
						}
					}
#line 199 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_tmp35_) {
#line 1528 "tracker-turtle-reader.c"
						gchar* ns = NULL;
						gchar* _tmp38_;
						gchar* _tmp41_ = NULL;
						const gchar* _tmp42_;
						gchar* _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						gchar* _tmp48_;
#line 201 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp38_ = tracker_turtle_reader_get_last_string (self, 0);
#line 201 "../src/libtracker-data/tracker-turtle-reader.vala"
						ns = _tmp38_;
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1549 "tracker-turtle-reader.c"
								gboolean _tmp39_ = FALSE;
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp39_;
#line 1557 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp40_ = FALSE;
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 202 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp40_;
#line 1568 "tracker-turtle-reader.c"
							}
						}
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp42_ = ns;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp43_ = tracker_turtle_reader_get_last_string (self, 0);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp44_ = _tmp43_;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp45_ = string_substring (_tmp44_, (glong) 1, (glong) -1);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp46_ = _tmp45_;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp47_ = tracker_turtle_reader_resolve_prefixed_name (self, _tmp42_, _tmp46_, &_inner_error0_);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp48_ = _tmp47_;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp46_);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp44_);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp41_ = _tmp48_;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1595 "tracker-turtle-reader.c"
								gboolean _tmp49_ = FALSE;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp49_;
#line 1603 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp50_ = FALSE;
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp50_;
#line 1614 "tracker-turtle-reader.c"
							}
						}
#line 203 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_set_subject (self, _tmp41_);
#line 204 "../src/libtracker-data/tracker-turtle-reader.vala"
						self->priv->state = TRACKER_TURTLE_READER_STATE_SUBJECT;
#line 205 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp41_);
#line 205 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (ns);
#line 205 "../src/libtracker-data/tracker-turtle-reader.vala"
						continue;
#line 1627 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp51_ = FALSE;
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp51_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1636 "tracker-turtle-reader.c"
								gboolean _tmp52_ = FALSE;
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp52_;
#line 1642 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp53_ = FALSE;
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp53_;
#line 1651 "tracker-turtle-reader.c"
							}
						}
#line 206 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_tmp51_) {
#line 1656 "tracker-turtle-reader.c"
							gchar* _tmp54_ = NULL;
							gchar* _tmp55_;
							gchar* _tmp56_;
							gchar* _tmp57_;
							gchar* _tmp58_;
							gchar* _tmp59_;
							gchar* _tmp60_;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp55_ = tracker_turtle_reader_get_last_string (self, 0);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp56_ = _tmp55_;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp57_ = string_substring (_tmp56_, (glong) 1, (glong) -1);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp58_ = _tmp57_;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp59_ = tracker_turtle_reader_resolve_prefixed_name (self, "", _tmp58_, &_inner_error0_);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp60_ = _tmp59_;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp58_);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp56_);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp54_ = _tmp60_;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1686 "tracker-turtle-reader.c"
									gboolean _tmp61_ = FALSE;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp61_;
#line 1692 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp62_ = FALSE;
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp62_;
#line 1701 "tracker-turtle-reader.c"
								}
							}
#line 208 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_subject (self, _tmp54_);
#line 209 "../src/libtracker-data/tracker-turtle-reader.vala"
							self->priv->state = TRACKER_TURTLE_READER_STATE_SUBJECT;
#line 210 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp54_);
#line 210 "../src/libtracker-data/tracker-turtle-reader.vala"
							continue;
#line 1712 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp63_ = FALSE;
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp63_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_BLANK_NODE, &_inner_error0_);
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1721 "tracker-turtle-reader.c"
									gboolean _tmp64_ = FALSE;
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp64_;
#line 1727 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp65_ = FALSE;
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp65_;
#line 1736 "tracker-turtle-reader.c"
								}
							}
#line 211 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_tmp63_) {
#line 1741 "tracker-turtle-reader.c"
								gchar* _tmp68_;
								gchar* _tmp69_;
								gchar* _tmp70_;
								gchar* _tmp71_;
								gchar* _tmp72_;
								gchar* _tmp73_;
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
								tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
									if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1754 "tracker-turtle-reader.c"
										gboolean _tmp66_ = FALSE;
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_propagate_error (error, _inner_error0_);
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
										return _tmp66_;
#line 1760 "tracker-turtle-reader.c"
									} else {
										gboolean _tmp67_ = FALSE;
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_clear_error (&_inner_error0_);
#line 213 "../src/libtracker-data/tracker-turtle-reader.vala"
										return _tmp67_;
#line 1769 "tracker-turtle-reader.c"
									}
								}
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp68_ = tracker_turtle_reader_get_last_string (self, 0);
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp69_ = _tmp68_;
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp70_ = string_substring (_tmp69_, (glong) 1, (glong) -1);
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp71_ = _tmp70_;
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp72_ = tracker_turtle_reader_generate_bnodeid (self, _tmp71_);
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp73_ = _tmp72_;
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								tracker_turtle_reader_set_subject (self, _tmp73_);
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (_tmp73_);
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (_tmp71_);
#line 214 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (_tmp69_);
#line 215 "../src/libtracker-data/tracker-turtle-reader.vala"
								self->priv->state = TRACKER_TURTLE_READER_STATE_SUBJECT;
#line 216 "../src/libtracker-data/tracker-turtle-reader.vala"
								continue;
#line 1796 "tracker-turtle-reader.c"
							} else {
								GError* _tmp74_;
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp74_ = tracker_turtle_reader_get_error (self, "expected subject");
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
								_inner_error0_ = _tmp74_;
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1805 "tracker-turtle-reader.c"
									gboolean _tmp75_ = FALSE;
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp75_;
#line 1811 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp76_ = FALSE;
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 218 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp76_;
#line 1820 "tracker-turtle-reader.c"
								}
							}
						}
					}
				}
			}
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
			case TRACKER_TURTLE_READER_STATE_SUBJECT:
#line 1829 "tracker-turtle-reader.c"
			{
				gboolean _tmp77_ = FALSE;
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp77_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1838 "tracker-turtle-reader.c"
						gboolean _tmp78_ = FALSE;
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_propagate_error (error, _inner_error0_);
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp78_;
#line 1844 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp79_ = FALSE;
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_clear_error (&_inner_error0_);
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp79_;
#line 1853 "tracker-turtle-reader.c"
					}
				}
#line 222 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_tmp77_) {
#line 1858 "tracker-turtle-reader.c"
					gchar* _tmp80_;
					gchar* _tmp81_;
#line 223 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp80_ = tracker_turtle_reader_get_last_string (self, 1);
#line 223 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp81_ = _tmp80_;
#line 223 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_set_predicate (self, _tmp81_);
#line 223 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_free0 (_tmp81_);
#line 224 "../src/libtracker-data/tracker-turtle-reader.vala"
					self->priv->state = TRACKER_TURTLE_READER_STATE_PREDICATE;
#line 225 "../src/libtracker-data/tracker-turtle-reader.vala"
					continue;
#line 1873 "tracker-turtle-reader.c"
				} else {
					gboolean _tmp82_ = FALSE;
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp82_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_PN_PREFIX, &_inner_error0_);
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1882 "tracker-turtle-reader.c"
							gboolean _tmp83_ = FALSE;
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp83_;
#line 1888 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp84_ = FALSE;
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp84_;
#line 1897 "tracker-turtle-reader.c"
						}
					}
#line 226 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_tmp82_) {
#line 1902 "tracker-turtle-reader.c"
						gchar* ns = NULL;
						gchar* _tmp85_;
						gchar* _tmp88_ = NULL;
						const gchar* _tmp89_;
						gchar* _tmp90_;
						gchar* _tmp91_;
						gchar* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
#line 227 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp85_ = tracker_turtle_reader_get_last_string (self, 0);
#line 227 "../src/libtracker-data/tracker-turtle-reader.vala"
						ns = _tmp85_;
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1923 "tracker-turtle-reader.c"
								gboolean _tmp86_ = FALSE;
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp86_;
#line 1931 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp87_ = FALSE;
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 228 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp87_;
#line 1942 "tracker-turtle-reader.c"
							}
						}
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp89_ = ns;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp90_ = tracker_turtle_reader_get_last_string (self, 0);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp91_ = _tmp90_;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp92_ = string_substring (_tmp91_, (glong) 1, (glong) -1);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp93_ = _tmp92_;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp94_ = tracker_turtle_reader_resolve_prefixed_name (self, _tmp89_, _tmp93_, &_inner_error0_);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp95_ = _tmp94_;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp93_);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp91_);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp88_ = _tmp95_;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 1969 "tracker-turtle-reader.c"
								gboolean _tmp96_ = FALSE;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp96_;
#line 1977 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp97_ = FALSE;
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp97_;
#line 1988 "tracker-turtle-reader.c"
							}
						}
#line 229 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_set_predicate (self, _tmp88_);
#line 230 "../src/libtracker-data/tracker-turtle-reader.vala"
						self->priv->state = TRACKER_TURTLE_READER_STATE_PREDICATE;
#line 231 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp88_);
#line 231 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (ns);
#line 231 "../src/libtracker-data/tracker-turtle-reader.vala"
						continue;
#line 2001 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp98_ = FALSE;
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp98_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2010 "tracker-turtle-reader.c"
								gboolean _tmp99_ = FALSE;
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp99_;
#line 2016 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp100_ = FALSE;
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp100_;
#line 2025 "tracker-turtle-reader.c"
							}
						}
#line 232 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_tmp98_) {
#line 2030 "tracker-turtle-reader.c"
							gchar* _tmp101_ = NULL;
							gchar* _tmp102_;
							gchar* _tmp103_;
							gchar* _tmp104_;
							gchar* _tmp105_;
							gchar* _tmp106_;
							gchar* _tmp107_;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp102_ = tracker_turtle_reader_get_last_string (self, 0);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp103_ = _tmp102_;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp104_ = string_substring (_tmp103_, (glong) 1, (glong) -1);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp105_ = _tmp104_;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp106_ = tracker_turtle_reader_resolve_prefixed_name (self, "", _tmp105_, &_inner_error0_);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp107_ = _tmp106_;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp105_);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp103_);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp101_ = _tmp107_;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2060 "tracker-turtle-reader.c"
									gboolean _tmp108_ = FALSE;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp108_;
#line 2066 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp109_ = FALSE;
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp109_;
#line 2075 "tracker-turtle-reader.c"
								}
							}
#line 233 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_predicate (self, _tmp101_);
#line 234 "../src/libtracker-data/tracker-turtle-reader.vala"
							self->priv->state = TRACKER_TURTLE_READER_STATE_PREDICATE;
#line 235 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp101_);
#line 235 "../src/libtracker-data/tracker-turtle-reader.vala"
							continue;
#line 2086 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp110_ = FALSE;
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp110_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_A, &_inner_error0_);
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2095 "tracker-turtle-reader.c"
									gboolean _tmp111_ = FALSE;
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp111_;
#line 2101 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp112_ = FALSE;
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp112_;
#line 2110 "tracker-turtle-reader.c"
								}
							}
#line 236 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_tmp110_) {
#line 237 "../src/libtracker-data/tracker-turtle-reader.vala"
								tracker_turtle_reader_set_predicate (self, "http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
#line 238 "../src/libtracker-data/tracker-turtle-reader.vala"
								self->priv->state = TRACKER_TURTLE_READER_STATE_PREDICATE;
#line 239 "../src/libtracker-data/tracker-turtle-reader.vala"
								continue;
#line 2121 "tracker-turtle-reader.c"
							} else {
								GError* _tmp113_;
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp113_ = tracker_turtle_reader_get_error (self, "expected predicate");
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
								_inner_error0_ = _tmp113_;
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2130 "tracker-turtle-reader.c"
									gboolean _tmp114_ = FALSE;
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp114_;
#line 2136 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp115_ = FALSE;
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 241 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp115_;
#line 2145 "tracker-turtle-reader.c"
								}
							}
						}
					}
				}
			}
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
			case TRACKER_TURTLE_READER_STATE_PREDICATE:
#line 2154 "tracker-turtle-reader.c"
			{
				gboolean _tmp116_ = FALSE;
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp116_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2163 "tracker-turtle-reader.c"
						gboolean _tmp117_ = FALSE;
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_propagate_error (error, _inner_error0_);
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp117_;
#line 2169 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp118_ = FALSE;
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_clear_error (&_inner_error0_);
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp118_;
#line 2178 "tracker-turtle-reader.c"
					}
				}
#line 245 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_tmp116_) {
#line 2183 "tracker-turtle-reader.c"
					gchar* _tmp119_;
					gchar* _tmp120_;
#line 246 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp119_ = tracker_turtle_reader_get_last_string (self, 1);
#line 246 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp120_ = _tmp119_;
#line 246 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_set_object (self, _tmp120_);
#line 246 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_free0 (_tmp120_);
#line 247 "../src/libtracker-data/tracker-turtle-reader.vala"
					tracker_turtle_reader_set_object_is_uri (self, TRUE);
#line 248 "../src/libtracker-data/tracker-turtle-reader.vala"
					self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 249 "../src/libtracker-data/tracker-turtle-reader.vala"
					result = TRUE;
#line 249 "../src/libtracker-data/tracker-turtle-reader.vala"
					return result;
#line 2202 "tracker-turtle-reader.c"
				} else {
					gboolean _tmp121_ = FALSE;
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp121_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_PN_PREFIX, &_inner_error0_);
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2211 "tracker-turtle-reader.c"
							gboolean _tmp122_ = FALSE;
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp122_;
#line 2217 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp123_ = FALSE;
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp123_;
#line 2226 "tracker-turtle-reader.c"
						}
					}
#line 250 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_tmp121_) {
#line 2231 "tracker-turtle-reader.c"
						gchar* ns = NULL;
						gchar* _tmp124_;
						gchar* _tmp127_ = NULL;
						const gchar* _tmp128_;
						gchar* _tmp129_;
						gchar* _tmp130_;
						gchar* _tmp131_;
						gchar* _tmp132_;
						gchar* _tmp133_;
						gchar* _tmp134_;
#line 252 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp124_ = tracker_turtle_reader_get_last_string (self, 0);
#line 252 "../src/libtracker-data/tracker-turtle-reader.vala"
						ns = _tmp124_;
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2252 "tracker-turtle-reader.c"
								gboolean _tmp125_ = FALSE;
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp125_;
#line 2260 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp126_ = FALSE;
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 253 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp126_;
#line 2271 "tracker-turtle-reader.c"
							}
						}
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp128_ = ns;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp129_ = tracker_turtle_reader_get_last_string (self, 0);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp130_ = _tmp129_;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp131_ = string_substring (_tmp130_, (glong) 1, (glong) -1);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp132_ = _tmp131_;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp133_ = tracker_turtle_reader_resolve_prefixed_name (self, _tmp128_, _tmp132_, &_inner_error0_);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp134_ = _tmp133_;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp132_);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp130_);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp127_ = _tmp134_;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2298 "tracker-turtle-reader.c"
								gboolean _tmp135_ = FALSE;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp135_;
#line 2306 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp136_ = FALSE;
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (ns);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp136_;
#line 2317 "tracker-turtle-reader.c"
							}
						}
#line 254 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_set_object (self, _tmp127_);
#line 255 "../src/libtracker-data/tracker-turtle-reader.vala"
						tracker_turtle_reader_set_object_is_uri (self, TRUE);
#line 256 "../src/libtracker-data/tracker-turtle-reader.vala"
						self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 257 "../src/libtracker-data/tracker-turtle-reader.vala"
						result = TRUE;
#line 257 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (_tmp127_);
#line 257 "../src/libtracker-data/tracker-turtle-reader.vala"
						_g_free0 (ns);
#line 257 "../src/libtracker-data/tracker-turtle-reader.vala"
						return result;
#line 2334 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp137_ = FALSE;
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp137_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2343 "tracker-turtle-reader.c"
								gboolean _tmp138_ = FALSE;
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp138_;
#line 2349 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp139_ = FALSE;
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp139_;
#line 2358 "tracker-turtle-reader.c"
							}
						}
#line 258 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_tmp137_) {
#line 2363 "tracker-turtle-reader.c"
							gchar* _tmp140_ = NULL;
							gchar* _tmp141_;
							gchar* _tmp142_;
							gchar* _tmp143_;
							gchar* _tmp144_;
							gchar* _tmp145_;
							gchar* _tmp146_;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp141_ = tracker_turtle_reader_get_last_string (self, 0);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp142_ = _tmp141_;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp143_ = string_substring (_tmp142_, (glong) 1, (glong) -1);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp144_ = _tmp143_;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp145_ = tracker_turtle_reader_resolve_prefixed_name (self, "", _tmp144_, &_inner_error0_);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp146_ = _tmp145_;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp144_);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp142_);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp140_ = _tmp146_;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2393 "tracker-turtle-reader.c"
									gboolean _tmp147_ = FALSE;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp147_;
#line 2399 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp148_ = FALSE;
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp148_;
#line 2408 "tracker-turtle-reader.c"
								}
							}
#line 260 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_object (self, _tmp140_);
#line 261 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_object_is_uri (self, TRUE);
#line 262 "../src/libtracker-data/tracker-turtle-reader.vala"
							self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 263 "../src/libtracker-data/tracker-turtle-reader.vala"
							result = TRUE;
#line 263 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp140_);
#line 263 "../src/libtracker-data/tracker-turtle-reader.vala"
							return result;
#line 2423 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp149_ = FALSE;
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp149_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_BLANK_NODE, &_inner_error0_);
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2432 "tracker-turtle-reader.c"
									gboolean _tmp150_ = FALSE;
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp150_;
#line 2438 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp151_ = FALSE;
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp151_;
#line 2447 "tracker-turtle-reader.c"
								}
							}
#line 264 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_tmp149_) {
#line 2452 "tracker-turtle-reader.c"
								gchar* _tmp154_;
								gchar* _tmp155_;
								gchar* _tmp156_;
								gchar* _tmp157_;
								gchar* _tmp158_;
								gchar* _tmp159_;
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
								tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
									if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2465 "tracker-turtle-reader.c"
										gboolean _tmp152_ = FALSE;
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_propagate_error (error, _inner_error0_);
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
										return _tmp152_;
#line 2471 "tracker-turtle-reader.c"
									} else {
										gboolean _tmp153_ = FALSE;
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_clear_error (&_inner_error0_);
#line 266 "../src/libtracker-data/tracker-turtle-reader.vala"
										return _tmp153_;
#line 2480 "tracker-turtle-reader.c"
									}
								}
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp154_ = tracker_turtle_reader_get_last_string (self, 0);
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp155_ = _tmp154_;
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp156_ = string_substring (_tmp155_, (glong) 1, (glong) -1);
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp157_ = _tmp156_;
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp158_ = tracker_turtle_reader_generate_bnodeid (self, _tmp157_);
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp159_ = _tmp158_;
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								tracker_turtle_reader_set_object (self, _tmp159_);
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (_tmp159_);
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (_tmp157_);
#line 267 "../src/libtracker-data/tracker-turtle-reader.vala"
								_g_free0 (_tmp155_);
#line 268 "../src/libtracker-data/tracker-turtle-reader.vala"
								tracker_turtle_reader_set_object_is_uri (self, TRUE);
#line 269 "../src/libtracker-data/tracker-turtle-reader.vala"
								self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 270 "../src/libtracker-data/tracker-turtle-reader.vala"
								result = TRUE;
#line 270 "../src/libtracker-data/tracker-turtle-reader.vala"
								return result;
#line 2511 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp160_ = FALSE;
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp160_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_OPEN_BRACKET, &_inner_error0_);
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
									if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2520 "tracker-turtle-reader.c"
										gboolean _tmp161_ = FALSE;
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_propagate_error (error, _inner_error0_);
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
										return _tmp161_;
#line 2526 "tracker-turtle-reader.c"
									} else {
										gboolean _tmp162_ = FALSE;
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
										g_clear_error (&_inner_error0_);
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
										return _tmp162_;
#line 2535 "tracker-turtle-reader.c"
									}
								}
#line 271 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_tmp160_) {
#line 2540 "tracker-turtle-reader.c"
									GQueue* _tmp163_;
									const gchar* _tmp164_;
									gchar* _tmp165_;
									GQueue* _tmp166_;
									const gchar* _tmp167_;
									gchar* _tmp168_;
									gchar* _tmp169_;
									gchar* _tmp170_;
#line 273 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp163_ = self->priv->subject_stack;
#line 273 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp164_ = self->priv->_subject;
#line 273 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp165_ = g_strdup (_tmp164_);
#line 273 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_queue_push_tail (_tmp163_, _tmp165_);
#line 274 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp166_ = self->priv->predicate_stack;
#line 274 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp167_ = self->priv->_predicate;
#line 274 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp168_ = g_strdup (_tmp167_);
#line 274 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_queue_push_tail (_tmp166_, _tmp168_);
#line 275 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp169_ = tracker_turtle_reader_generate_bnodeid (self, NULL);
#line 275 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp170_ = _tmp169_;
#line 275 "../src/libtracker-data/tracker-turtle-reader.vala"
									tracker_turtle_reader_set_subject (self, _tmp170_);
#line 275 "../src/libtracker-data/tracker-turtle-reader.vala"
									_g_free0 (_tmp170_);
#line 276 "../src/libtracker-data/tracker-turtle-reader.vala"
									self->priv->state = TRACKER_TURTLE_READER_STATE_SUBJECT;
#line 277 "../src/libtracker-data/tracker-turtle-reader.vala"
									continue;
#line 2577 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp171_ = FALSE;
									gboolean _tmp172_ = FALSE;
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
									_tmp172_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_STRING_LITERAL1, &_inner_error0_);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2587 "tracker-turtle-reader.c"
											gboolean _tmp173_ = FALSE;
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
											g_propagate_error (error, _inner_error0_);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
											return _tmp173_;
#line 2593 "tracker-turtle-reader.c"
										} else {
											gboolean _tmp174_ = FALSE;
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
											g_clear_error (&_inner_error0_);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
											return _tmp174_;
#line 2602 "tracker-turtle-reader.c"
										}
									}
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
									if (_tmp172_) {
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp171_ = TRUE;
#line 2609 "tracker-turtle-reader.c"
									} else {
										gboolean _tmp175_ = FALSE;
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp175_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_STRING_LITERAL2, &_inner_error0_);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2618 "tracker-turtle-reader.c"
												gboolean _tmp176_ = FALSE;
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_propagate_error (error, _inner_error0_);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
												return _tmp176_;
#line 2624 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp177_ = FALSE;
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_clear_error (&_inner_error0_);
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
												return _tmp177_;
#line 2633 "tracker-turtle-reader.c"
											}
										}
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp171_ = _tmp175_;
#line 2638 "tracker-turtle-reader.c"
									}
#line 278 "../src/libtracker-data/tracker-turtle-reader.vala"
									if (_tmp171_) {
#line 2642 "tracker-turtle-reader.c"
										GString* sb = NULL;
										GString* _tmp178_;
										gchar* s = NULL;
										gchar* _tmp179_;
										const gchar* p = NULL;
										const gchar* _tmp180_;
										const gchar* end = NULL;
										const gchar* _tmp181_;
										const gchar* _tmp182_;
										gint _tmp183_;
										gint _tmp184_;
										GString* _tmp211_;
										const gchar* _tmp212_;
										gboolean _tmp213_ = FALSE;
#line 279 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp178_ = g_string_new ("");
#line 279 "../src/libtracker-data/tracker-turtle-reader.vala"
										sb = _tmp178_;
#line 281 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp179_ = tracker_turtle_reader_get_last_string (self, 1);
#line 281 "../src/libtracker-data/tracker-turtle-reader.vala"
										s = _tmp179_;
#line 282 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp180_ = s;
#line 282 "../src/libtracker-data/tracker-turtle-reader.vala"
										p = _tmp180_;
#line 283 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp181_ = p;
#line 283 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp182_ = s;
#line 283 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp183_ = strlen (_tmp182_);
#line 283 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp184_ = _tmp183_;
#line 283 "../src/libtracker-data/tracker-turtle-reader.vala"
										end = _tmp181_ + _tmp184_;
#line 284 "../src/libtracker-data/tracker-turtle-reader.vala"
										while (TRUE) {
#line 2681 "tracker-turtle-reader.c"
											const gchar* _tmp185_;
											const gchar* _tmp186_;
											const gchar* q = NULL;
											const gchar* _tmp187_;
											const gchar* _tmp188_;
											const gchar* _tmp189_;
#line 284 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp185_ = p;
#line 284 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp186_ = end;
#line 284 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (!(((glong) _tmp185_) < ((glong) _tmp186_))) {
#line 284 "../src/libtracker-data/tracker-turtle-reader.vala"
												break;
#line 2696 "tracker-turtle-reader.c"
											}
#line 285 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp187_ = p;
#line 285 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp188_ = strchr (_tmp187_, (gint) '\\');
#line 285 "../src/libtracker-data/tracker-turtle-reader.vala"
											q = _tmp188_;
#line 286 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp189_ = q;
#line 286 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp189_ == NULL) {
#line 2708 "tracker-turtle-reader.c"
												GString* _tmp190_;
												const gchar* _tmp191_;
												const gchar* _tmp192_;
												const gchar* _tmp193_;
												const gchar* _tmp194_;
#line 287 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp190_ = sb;
#line 287 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp191_ = p;
#line 287 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp192_ = end;
#line 287 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp193_ = p;
#line 287 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_string_append_len (_tmp190_, _tmp191_, (gssize) ((glong) (_tmp192_ - _tmp193_)));
#line 288 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp194_ = end;
#line 288 "../src/libtracker-data/tracker-turtle-reader.vala"
												p = _tmp194_;
#line 2728 "tracker-turtle-reader.c"
											} else {
												GString* _tmp195_;
												const gchar* _tmp196_;
												const gchar* _tmp197_;
												const gchar* _tmp198_;
												const gchar* _tmp199_;
												const gchar* _tmp200_;
												gchar _tmp201_;
												const gchar* _tmp210_;
#line 290 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp195_ = sb;
#line 290 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp196_ = p;
#line 290 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp197_ = q;
#line 290 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp198_ = p;
#line 290 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_string_append_len (_tmp195_, _tmp196_, (gssize) ((glong) (_tmp197_ - _tmp198_)));
#line 291 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp199_ = q;
#line 291 "../src/libtracker-data/tracker-turtle-reader.vala"
												p = _tmp199_ + 1;
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp200_ = p;
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp201_ = ((gchar*) _tmp200_)[0];
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
												switch (_tmp201_) {
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case '\'':
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case '"':
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case '\\':
#line 2764 "tracker-turtle-reader.c"
													{
														GString* _tmp202_;
														const gchar* _tmp203_;
														gchar _tmp204_;
#line 296 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp202_ = sb;
#line 296 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp203_ = p;
#line 296 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp204_ = ((gchar*) _tmp203_)[0];
#line 296 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_string_append_c (_tmp202_, _tmp204_);
#line 297 "../src/libtracker-data/tracker-turtle-reader.vala"
														break;
#line 2779 "tracker-turtle-reader.c"
													}
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case 'b':
#line 2783 "tracker-turtle-reader.c"
													{
														GString* _tmp205_;
#line 299 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp205_ = sb;
#line 299 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_string_append_c (_tmp205_, '\b');
#line 300 "../src/libtracker-data/tracker-turtle-reader.vala"
														break;
#line 2792 "tracker-turtle-reader.c"
													}
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case 'f':
#line 2796 "tracker-turtle-reader.c"
													{
														GString* _tmp206_;
#line 302 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp206_ = sb;
#line 302 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_string_append_c (_tmp206_, '\f');
#line 303 "../src/libtracker-data/tracker-turtle-reader.vala"
														break;
#line 2805 "tracker-turtle-reader.c"
													}
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case 'n':
#line 2809 "tracker-turtle-reader.c"
													{
														GString* _tmp207_;
#line 305 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp207_ = sb;
#line 305 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_string_append_c (_tmp207_, '\n');
#line 306 "../src/libtracker-data/tracker-turtle-reader.vala"
														break;
#line 2818 "tracker-turtle-reader.c"
													}
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case 'r':
#line 2822 "tracker-turtle-reader.c"
													{
														GString* _tmp208_;
#line 308 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp208_ = sb;
#line 308 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_string_append_c (_tmp208_, '\r');
#line 309 "../src/libtracker-data/tracker-turtle-reader.vala"
														break;
#line 2831 "tracker-turtle-reader.c"
													}
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													case 't':
#line 2835 "tracker-turtle-reader.c"
													{
														GString* _tmp209_;
#line 311 "../src/libtracker-data/tracker-turtle-reader.vala"
														_tmp209_ = sb;
#line 311 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_string_append_c (_tmp209_, '\t');
#line 312 "../src/libtracker-data/tracker-turtle-reader.vala"
														break;
#line 2844 "tracker-turtle-reader.c"
													}
													default:
#line 292 "../src/libtracker-data/tracker-turtle-reader.vala"
													break;
#line 2849 "tracker-turtle-reader.c"
												}
#line 314 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp210_ = p;
#line 314 "../src/libtracker-data/tracker-turtle-reader.vala"
												p = _tmp210_ + 1;
#line 2855 "tracker-turtle-reader.c"
											}
										}
#line 317 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp211_ = sb;
#line 317 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp212_ = _tmp211_->str;
#line 317 "../src/libtracker-data/tracker-turtle-reader.vala"
										tracker_turtle_reader_set_object (self, _tmp212_);
#line 318 "../src/libtracker-data/tracker-turtle-reader.vala"
										tracker_turtle_reader_set_object_is_uri (self, FALSE);
#line 319 "../src/libtracker-data/tracker-turtle-reader.vala"
										self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp213_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_DOUBLE_CIRCUMFLEX, &_inner_error0_);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2874 "tracker-turtle-reader.c"
												gboolean _tmp214_ = FALSE;
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_propagate_error (error, _inner_error0_);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												_g_free0 (s);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												_g_string_free0 (sb);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												return _tmp214_;
#line 2884 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp215_ = FALSE;
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												_g_free0 (s);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												_g_string_free0 (sb);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_clear_error (&_inner_error0_);
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
												return _tmp215_;
#line 2897 "tracker-turtle-reader.c"
											}
										}
#line 321 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (_tmp213_) {
#line 2902 "tracker-turtle-reader.c"
											gboolean _tmp216_ = FALSE;
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp216_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2910 "tracker-turtle-reader.c"
													gboolean _tmp217_ = FALSE;
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_propagate_error (error, _inner_error0_);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													_g_free0 (s);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													_g_string_free0 (sb);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp217_;
#line 2920 "tracker-turtle-reader.c"
												} else {
													gboolean _tmp218_ = FALSE;
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													_g_free0 (s);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													_g_string_free0 (sb);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_clear_error (&_inner_error0_);
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp218_;
#line 2933 "tracker-turtle-reader.c"
												}
											}
#line 322 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (!_tmp216_) {
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
												tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_PN_PREFIX, &_inner_error0_);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2944 "tracker-turtle-reader.c"
														gboolean _tmp219_ = FALSE;
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_free0 (s);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_string_free0 (sb);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp219_;
#line 2954 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp220_ = FALSE;
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_free0 (s);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_string_free0 (sb);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 323 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp220_;
#line 2967 "tracker-turtle-reader.c"
													}
												}
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
												tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 2976 "tracker-turtle-reader.c"
														gboolean _tmp221_ = FALSE;
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_free0 (s);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_string_free0 (sb);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp221_;
#line 2986 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp222_ = FALSE;
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_free0 (s);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														_g_string_free0 (sb);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 324 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp222_;
#line 2999 "tracker-turtle-reader.c"
													}
												}
											}
										}
#line 328 "../src/libtracker-data/tracker-turtle-reader.vala"
										result = TRUE;
#line 328 "../src/libtracker-data/tracker-turtle-reader.vala"
										_g_free0 (s);
#line 328 "../src/libtracker-data/tracker-turtle-reader.vala"
										_g_string_free0 (sb);
#line 328 "../src/libtracker-data/tracker-turtle-reader.vala"
										return result;
#line 3012 "tracker-turtle-reader.c"
									} else {
										gboolean _tmp223_ = FALSE;
										gboolean _tmp224_ = FALSE;
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
										_tmp224_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_STRING_LITERAL_LONG1, &_inner_error0_);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3022 "tracker-turtle-reader.c"
												gboolean _tmp225_ = FALSE;
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_propagate_error (error, _inner_error0_);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
												return _tmp225_;
#line 3028 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp226_ = FALSE;
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
												g_clear_error (&_inner_error0_);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
												return _tmp226_;
#line 3037 "tracker-turtle-reader.c"
											}
										}
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (_tmp224_) {
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp223_ = TRUE;
#line 3044 "tracker-turtle-reader.c"
										} else {
											gboolean _tmp227_ = FALSE;
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp227_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_STRING_LITERAL_LONG2, &_inner_error0_);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3053 "tracker-turtle-reader.c"
													gboolean _tmp228_ = FALSE;
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_propagate_error (error, _inner_error0_);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp228_;
#line 3059 "tracker-turtle-reader.c"
												} else {
													gboolean _tmp229_ = FALSE;
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_clear_error (&_inner_error0_);
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp229_;
#line 3068 "tracker-turtle-reader.c"
												}
											}
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp223_ = _tmp227_;
#line 3073 "tracker-turtle-reader.c"
										}
#line 329 "../src/libtracker-data/tracker-turtle-reader.vala"
										if (_tmp223_) {
#line 3077 "tracker-turtle-reader.c"
											gchar* _tmp230_;
											gchar* _tmp231_;
											gboolean _tmp232_ = FALSE;
#line 330 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp230_ = tracker_turtle_reader_get_last_string (self, 3);
#line 330 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp231_ = _tmp230_;
#line 330 "../src/libtracker-data/tracker-turtle-reader.vala"
											tracker_turtle_reader_set_object (self, _tmp231_);
#line 330 "../src/libtracker-data/tracker-turtle-reader.vala"
											_g_free0 (_tmp231_);
#line 331 "../src/libtracker-data/tracker-turtle-reader.vala"
											tracker_turtle_reader_set_object_is_uri (self, FALSE);
#line 332 "../src/libtracker-data/tracker-turtle-reader.vala"
											self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp232_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_DOUBLE_CIRCUMFLEX, &_inner_error0_);
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3099 "tracker-turtle-reader.c"
													gboolean _tmp233_ = FALSE;
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_propagate_error (error, _inner_error0_);
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp233_;
#line 3105 "tracker-turtle-reader.c"
												} else {
													gboolean _tmp234_ = FALSE;
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_clear_error (&_inner_error0_);
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp234_;
#line 3114 "tracker-turtle-reader.c"
												}
											}
#line 334 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp232_) {
#line 3119 "tracker-turtle-reader.c"
												gboolean _tmp235_ = FALSE;
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp235_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_IRI_REF, &_inner_error0_);
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3127 "tracker-turtle-reader.c"
														gboolean _tmp236_ = FALSE;
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp236_;
#line 3133 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp237_ = FALSE;
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp237_;
#line 3142 "tracker-turtle-reader.c"
													}
												}
#line 335 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (!_tmp235_) {
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
													tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_PN_PREFIX, &_inner_error0_);
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
														if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3153 "tracker-turtle-reader.c"
															gboolean _tmp238_ = FALSE;
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
															g_propagate_error (error, _inner_error0_);
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
															return _tmp238_;
#line 3159 "tracker-turtle-reader.c"
														} else {
															gboolean _tmp239_ = FALSE;
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
															g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
															g_clear_error (&_inner_error0_);
#line 336 "../src/libtracker-data/tracker-turtle-reader.vala"
															return _tmp239_;
#line 3168 "tracker-turtle-reader.c"
														}
													}
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
													tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_COLON, &_inner_error0_);
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
														if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3177 "tracker-turtle-reader.c"
															gboolean _tmp240_ = FALSE;
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
															g_propagate_error (error, _inner_error0_);
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
															return _tmp240_;
#line 3183 "tracker-turtle-reader.c"
														} else {
															gboolean _tmp241_ = FALSE;
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
															g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
															g_clear_error (&_inner_error0_);
#line 337 "../src/libtracker-data/tracker-turtle-reader.vala"
															return _tmp241_;
#line 3192 "tracker-turtle-reader.c"
														}
													}
												}
											}
#line 341 "../src/libtracker-data/tracker-turtle-reader.vala"
											result = TRUE;
#line 341 "../src/libtracker-data/tracker-turtle-reader.vala"
											return result;
#line 3201 "tracker-turtle-reader.c"
										} else {
											gboolean _tmp242_ = FALSE;
											gboolean _tmp243_ = FALSE;
											gboolean _tmp244_ = FALSE;
											gboolean _tmp245_ = FALSE;
											gboolean _tmp246_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											_tmp246_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_INTEGER, &_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3214 "tracker-turtle-reader.c"
													gboolean _tmp247_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_propagate_error (error, _inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp247_;
#line 3220 "tracker-turtle-reader.c"
												} else {
													gboolean _tmp248_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_clear_error (&_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp248_;
#line 3229 "tracker-turtle-reader.c"
												}
											}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp246_) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp245_ = TRUE;
#line 3236 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp249_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp249_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_DECIMAL, &_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3245 "tracker-turtle-reader.c"
														gboolean _tmp250_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp250_;
#line 3251 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp251_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp251_;
#line 3260 "tracker-turtle-reader.c"
													}
												}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp245_ = _tmp249_;
#line 3265 "tracker-turtle-reader.c"
											}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp245_) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp244_ = TRUE;
#line 3271 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp252_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp252_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_DOUBLE, &_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3280 "tracker-turtle-reader.c"
														gboolean _tmp253_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp253_;
#line 3286 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp254_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp254_;
#line 3295 "tracker-turtle-reader.c"
													}
												}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp244_ = _tmp252_;
#line 3300 "tracker-turtle-reader.c"
											}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp244_) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp243_ = TRUE;
#line 3306 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp255_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp255_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_TRUE, &_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3315 "tracker-turtle-reader.c"
														gboolean _tmp256_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp256_;
#line 3321 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp257_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp257_;
#line 3330 "tracker-turtle-reader.c"
													}
												}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp243_ = _tmp255_;
#line 3335 "tracker-turtle-reader.c"
											}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp243_) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp242_ = TRUE;
#line 3341 "tracker-turtle-reader.c"
											} else {
												gboolean _tmp258_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp258_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_FALSE, &_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
													if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3350 "tracker-turtle-reader.c"
														gboolean _tmp259_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_propagate_error (error, _inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp259_;
#line 3356 "tracker-turtle-reader.c"
													} else {
														gboolean _tmp260_ = FALSE;
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														g_clear_error (&_inner_error0_);
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
														return _tmp260_;
#line 3365 "tracker-turtle-reader.c"
													}
												}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp242_ = _tmp258_;
#line 3370 "tracker-turtle-reader.c"
											}
#line 342 "../src/libtracker-data/tracker-turtle-reader.vala"
											if (_tmp242_) {
#line 3374 "tracker-turtle-reader.c"
												gchar* _tmp261_;
												gchar* _tmp262_;
#line 343 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp261_ = tracker_turtle_reader_get_last_string (self, 0);
#line 343 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp262_ = _tmp261_;
#line 343 "../src/libtracker-data/tracker-turtle-reader.vala"
												tracker_turtle_reader_set_object (self, _tmp262_);
#line 343 "../src/libtracker-data/tracker-turtle-reader.vala"
												_g_free0 (_tmp262_);
#line 344 "../src/libtracker-data/tracker-turtle-reader.vala"
												tracker_turtle_reader_set_object_is_uri (self, FALSE);
#line 345 "../src/libtracker-data/tracker-turtle-reader.vala"
												self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 346 "../src/libtracker-data/tracker-turtle-reader.vala"
												result = TRUE;
#line 346 "../src/libtracker-data/tracker-turtle-reader.vala"
												return result;
#line 3393 "tracker-turtle-reader.c"
											} else {
												GError* _tmp263_;
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
												_tmp263_ = tracker_turtle_reader_get_error (self, "expected object");
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
												_inner_error0_ = _tmp263_;
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
												if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3402 "tracker-turtle-reader.c"
													gboolean _tmp264_ = FALSE;
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_propagate_error (error, _inner_error0_);
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp264_;
#line 3408 "tracker-turtle-reader.c"
												} else {
													gboolean _tmp265_ = FALSE;
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
													g_clear_error (&_inner_error0_);
#line 348 "../src/libtracker-data/tracker-turtle-reader.vala"
													return _tmp265_;
#line 3417 "tracker-turtle-reader.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
			case TRACKER_TURTLE_READER_STATE_OBJECT:
#line 3430 "tracker-turtle-reader.c"
			{
				gboolean _tmp266_ = FALSE;
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp266_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_COMMA, &_inner_error0_);
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3439 "tracker-turtle-reader.c"
						gboolean _tmp267_ = FALSE;
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_propagate_error (error, _inner_error0_);
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp267_;
#line 3445 "tracker-turtle-reader.c"
					} else {
						gboolean _tmp268_ = FALSE;
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
						g_clear_error (&_inner_error0_);
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
						return _tmp268_;
#line 3454 "tracker-turtle-reader.c"
					}
				}
#line 351 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_tmp266_) {
#line 352 "../src/libtracker-data/tracker-turtle-reader.vala"
					self->priv->state = TRACKER_TURTLE_READER_STATE_PREDICATE;
#line 353 "../src/libtracker-data/tracker-turtle-reader.vala"
					continue;
#line 3463 "tracker-turtle-reader.c"
				} else {
					gboolean _tmp269_ = FALSE;
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
					_tmp269_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3472 "tracker-turtle-reader.c"
							gboolean _tmp270_ = FALSE;
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp270_;
#line 3478 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp271_ = FALSE;
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
							g_clear_error (&_inner_error0_);
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
							return _tmp271_;
#line 3487 "tracker-turtle-reader.c"
						}
					}
#line 354 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_tmp269_) {
#line 3492 "tracker-turtle-reader.c"
						gboolean _tmp272_ = FALSE;
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp272_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_DOT, &_inner_error0_);
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3500 "tracker-turtle-reader.c"
								gboolean _tmp273_ = FALSE;
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_propagate_error (error, _inner_error0_);
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp273_;
#line 3506 "tracker-turtle-reader.c"
							} else {
								gboolean _tmp274_ = FALSE;
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
								g_clear_error (&_inner_error0_);
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
								return _tmp274_;
#line 3515 "tracker-turtle-reader.c"
							}
						}
#line 355 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (_tmp272_) {
#line 357 "../src/libtracker-data/tracker-turtle-reader.vala"
							self->priv->state = TRACKER_TURTLE_READER_STATE_BOS;
#line 358 "../src/libtracker-data/tracker-turtle-reader.vala"
							continue;
#line 3524 "tracker-turtle-reader.c"
						}
#line 360 "../src/libtracker-data/tracker-turtle-reader.vala"
						self->priv->state = TRACKER_TURTLE_READER_STATE_SUBJECT;
#line 361 "../src/libtracker-data/tracker-turtle-reader.vala"
						continue;
#line 3530 "tracker-turtle-reader.c"
					} else {
						GQueue* _tmp275_;
#line 362 "../src/libtracker-data/tracker-turtle-reader.vala"
						_tmp275_ = self->priv->subject_stack;
#line 362 "../src/libtracker-data/tracker-turtle-reader.vala"
						if (!g_queue_is_empty (_tmp275_)) {
#line 3537 "tracker-turtle-reader.c"
							const gchar* _tmp278_;
							GQueue* _tmp279_;
							gpointer _tmp280_;
							gchar* _tmp281_;
							GQueue* _tmp282_;
							gpointer _tmp283_;
							gchar* _tmp284_;
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_expect (self, TRACKER_SPARQL_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3551 "tracker-turtle-reader.c"
									gboolean _tmp276_ = FALSE;
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp276_;
#line 3557 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp277_ = FALSE;
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 364 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp277_;
#line 3566 "tracker-turtle-reader.c"
								}
							}
#line 366 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp278_ = self->priv->_subject;
#line 366 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_object (self, _tmp278_);
#line 367 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_object_is_uri (self, TRUE);
#line 369 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp279_ = self->priv->subject_stack;
#line 369 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp280_ = g_queue_pop_tail (_tmp279_);
#line 369 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp281_ = (gchar*) _tmp280_;
#line 369 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_subject (self, _tmp281_);
#line 369 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp281_);
#line 370 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp282_ = self->priv->predicate_stack;
#line 370 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp283_ = g_queue_pop_tail (_tmp282_);
#line 370 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp284_ = (gchar*) _tmp283_;
#line 370 "../src/libtracker-data/tracker-turtle-reader.vala"
							tracker_turtle_reader_set_predicate (self, _tmp284_);
#line 370 "../src/libtracker-data/tracker-turtle-reader.vala"
							_g_free0 (_tmp284_);
#line 372 "../src/libtracker-data/tracker-turtle-reader.vala"
							self->priv->state = TRACKER_TURTLE_READER_STATE_OBJECT;
#line 373 "../src/libtracker-data/tracker-turtle-reader.vala"
							result = TRUE;
#line 373 "../src/libtracker-data/tracker-turtle-reader.vala"
							return result;
#line 3601 "tracker-turtle-reader.c"
						} else {
							gboolean _tmp285_ = FALSE;
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
							_tmp285_ = tracker_turtle_reader_accept (self, TRACKER_SPARQL_TOKEN_TYPE_DOT, &_inner_error0_);
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3610 "tracker-turtle-reader.c"
									gboolean _tmp286_ = FALSE;
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp286_;
#line 3616 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp287_ = FALSE;
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp287_;
#line 3625 "tracker-turtle-reader.c"
								}
							}
#line 374 "../src/libtracker-data/tracker-turtle-reader.vala"
							if (_tmp285_) {
#line 375 "../src/libtracker-data/tracker-turtle-reader.vala"
								self->priv->state = TRACKER_TURTLE_READER_STATE_BOS;
#line 376 "../src/libtracker-data/tracker-turtle-reader.vala"
								continue;
#line 3634 "tracker-turtle-reader.c"
							} else {
								GError* _tmp288_;
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
								_tmp288_ = tracker_turtle_reader_get_error (self, "expected comma, semicolon, or dot");
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
								_inner_error0_ = _tmp288_;
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
								if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3643 "tracker-turtle-reader.c"
									gboolean _tmp289_ = FALSE;
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_propagate_error (error, _inner_error0_);
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp289_;
#line 3649 "tracker-turtle-reader.c"
								} else {
									gboolean _tmp290_ = FALSE;
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
									g_clear_error (&_inner_error0_);
#line 378 "../src/libtracker-data/tracker-turtle-reader.vala"
									return _tmp290_;
#line 3658 "tracker-turtle-reader.c"
								}
							}
						}
					}
				}
			}
			default:
#line 169 "../src/libtracker-data/tracker-turtle-reader.vala"
			break;
#line 3668 "tracker-turtle-reader.c"
		}
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 401 "../src/libtracker-data/tracker-turtle-reader.vala"
	return self ? g_error_copy (self) : NULL;
#line 3678 "tracker-turtle-reader.c"
}

void
tracker_turtle_reader_load (GFile* file,
                            TrackerData* data,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
#line 384 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (file != NULL);
#line 384 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (data != NULL);
#line 3691 "tracker-turtle-reader.c"
	{
		TrackerTurtleReader* reader = NULL;
		TrackerTurtleReader* _tmp0_;
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_data_begin_transaction (data, &_inner_error0_);
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3701 "tracker-turtle-reader.c"
				goto __catch0_tracker_sparql_error;
			}
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3706 "tracker-turtle-reader.c"
				goto __catch0_tracker_db_interface_error;
			}
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_clear_error (&_inner_error0_);
#line 386 "../src/libtracker-data/tracker-turtle-reader.vala"
			return;
#line 3715 "tracker-turtle-reader.c"
		}
#line 388 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = tracker_turtle_reader_new (file, &_inner_error0_);
#line 388 "../src/libtracker-data/tracker-turtle-reader.vala"
		reader = _tmp0_;
#line 388 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 388 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3725 "tracker-turtle-reader.c"
				goto __catch0_tracker_sparql_error;
			}
#line 388 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3730 "tracker-turtle-reader.c"
				goto __catch0_tracker_db_interface_error;
			}
			goto __finally0;
		}
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
		while (TRUE) {
#line 3737 "tracker-turtle-reader.c"
			gboolean _tmp1_ = FALSE;
			TrackerTurtleReader* _tmp2_;
			TrackerTurtleReader* _tmp3_;
			gboolean _tmp4_;
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
			_tmp2_ = reader;
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
			_tmp1_ = tracker_turtle_reader_next (_tmp2_, &_inner_error0_);
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				_g_object_unref0 (reader);
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3752 "tracker-turtle-reader.c"
					goto __catch0_tracker_sparql_error;
				}
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3757 "tracker-turtle-reader.c"
					goto __catch0_tracker_db_interface_error;
				}
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_clear_error (&_inner_error0_);
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				return;
#line 3766 "tracker-turtle-reader.c"
			}
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (!_tmp1_) {
#line 389 "../src/libtracker-data/tracker-turtle-reader.vala"
				break;
#line 3772 "tracker-turtle-reader.c"
			}
#line 390 "../src/libtracker-data/tracker-turtle-reader.vala"
			_tmp3_ = reader;
#line 390 "../src/libtracker-data/tracker-turtle-reader.vala"
			_tmp4_ = _tmp3_->priv->_object_is_uri;
#line 390 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_tmp4_) {
#line 3780 "tracker-turtle-reader.c"
				TrackerTurtleReader* _tmp5_;
				const gchar* _tmp6_;
				TrackerTurtleReader* _tmp7_;
				const gchar* _tmp8_;
				TrackerTurtleReader* _tmp9_;
				const gchar* _tmp10_;
				TrackerTurtleReader* _tmp11_;
				const gchar* _tmp12_;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp5_ = reader;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp6_ = _tmp5_->priv->_graph;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp7_ = reader;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp8_ = _tmp7_->priv->_subject;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp9_ = reader;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp10_ = _tmp9_->priv->_predicate;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp11_ = reader;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp12_ = _tmp11_->priv->_object;
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				tracker_data_insert_statement_with_uri (data, _tmp6_, _tmp8_, _tmp10_, _tmp12_, &_inner_error0_);
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_object_unref0 (reader);
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3813 "tracker-turtle-reader.c"
						goto __catch0_tracker_sparql_error;
					}
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3818 "tracker-turtle-reader.c"
						goto __catch0_tracker_db_interface_error;
					}
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
					g_clear_error (&_inner_error0_);
#line 391 "../src/libtracker-data/tracker-turtle-reader.vala"
					return;
#line 3827 "tracker-turtle-reader.c"
				}
			} else {
				TrackerTurtleReader* _tmp13_;
				const gchar* _tmp14_;
				TrackerTurtleReader* _tmp15_;
				const gchar* _tmp16_;
				TrackerTurtleReader* _tmp17_;
				const gchar* _tmp18_;
				TrackerTurtleReader* _tmp19_;
				const gchar* _tmp20_;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp13_ = reader;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp14_ = _tmp13_->priv->_graph;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp15_ = reader;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp16_ = _tmp15_->priv->_subject;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp17_ = reader;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp18_ = _tmp17_->priv->_predicate;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp19_ = reader;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				_tmp20_ = _tmp19_->priv->_object;
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				tracker_data_insert_statement_with_string (data, _tmp14_, _tmp16_, _tmp18_, _tmp20_, &_inner_error0_);
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
					_g_object_unref0 (reader);
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3862 "tracker-turtle-reader.c"
						goto __catch0_tracker_sparql_error;
					}
#line 393 "../src/libtracker-data/tracker-turtle-reader.vala"
					if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3867 "tracker-turtle-reader.c"
						goto __catch0_tracker_db_interface_error;
					}
					goto __finally0;
				}
			}
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
			tracker_data_update_buffer_might_flush (data, &_inner_error0_);
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
				_g_object_unref0 (reader);
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3881 "tracker-turtle-reader.c"
					goto __catch0_tracker_sparql_error;
				}
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
				if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3886 "tracker-turtle-reader.c"
					goto __catch0_tracker_db_interface_error;
				}
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
				g_clear_error (&_inner_error0_);
#line 395 "../src/libtracker-data/tracker-turtle-reader.vala"
				return;
#line 3895 "tracker-turtle-reader.c"
			}
		}
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_data_commit_transaction (data, &_inner_error0_);
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
			_g_object_unref0 (reader);
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_SPARQL_ERROR) {
#line 3906 "tracker-turtle-reader.c"
				goto __catch0_tracker_sparql_error;
			}
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
			if (_inner_error0_->domain == TRACKER_DB_INTERFACE_ERROR) {
#line 3911 "tracker-turtle-reader.c"
				goto __catch0_tracker_db_interface_error;
			}
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
			g_clear_error (&_inner_error0_);
#line 398 "../src/libtracker-data/tracker-turtle-reader.vala"
			return;
#line 3920 "tracker-turtle-reader.c"
		}
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_object_unref0 (reader);
#line 3924 "tracker-turtle-reader.c"
	}
	goto __finally0;
	__catch0_tracker_sparql_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		GError* _tmp22_;
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		e = _inner_error0_;
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		_inner_error0_ = NULL;
#line 400 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_data_rollback_transaction (data);
#line 401 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp21_ = e;
#line 401 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp22_ = _g_error_copy0 (_tmp21_);
#line 401 "../src/libtracker-data/tracker-turtle-reader.vala"
		_inner_error0_ = _tmp22_;
#line 401 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_error_free0 (e);
#line 3946 "tracker-turtle-reader.c"
		goto __finally0;
	}
	goto __finally0;
	__catch0_tracker_db_interface_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		GError* _tmp24_;
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		e = _inner_error0_;
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		_inner_error0_ = NULL;
#line 403 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_data_rollback_transaction (data);
#line 404 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp23_ = e;
#line 404 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp24_ = _g_error_copy0 (_tmp23_);
#line 404 "../src/libtracker-data/tracker-turtle-reader.vala"
		_inner_error0_ = _tmp24_;
#line 404 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_error_free0 (e);
#line 3969 "tracker-turtle-reader.c"
		goto __finally0;
	}
	__finally0:
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_propagate_error (error, _inner_error0_);
#line 385 "../src/libtracker-data/tracker-turtle-reader.vala"
		return;
#line 3979 "tracker-turtle-reader.c"
	}
}

const gchar*
tracker_turtle_reader_get_graph (TrackerTurtleReader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->_graph;
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp0_;
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 3996 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_set_graph (TrackerTurtleReader* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	old_value = tracker_turtle_reader_get_graph (self);
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4010 "tracker-turtle-reader.c"
		gchar* _tmp0_;
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (self->priv->_graph);
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->_graph = _tmp0_;
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_object_notify_by_pspec ((GObject *) self, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_GRAPH_PROPERTY]);
#line 4020 "tracker-turtle-reader.c"
	}
}

const gchar*
tracker_turtle_reader_get_subject (TrackerTurtleReader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->_subject;
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp0_;
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 4037 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_set_subject (TrackerTurtleReader* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	old_value = tracker_turtle_reader_get_subject (self);
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4051 "tracker-turtle-reader.c"
		gchar* _tmp0_;
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (self->priv->_subject);
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->_subject = _tmp0_;
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_object_notify_by_pspec ((GObject *) self, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_SUBJECT_PROPERTY]);
#line 4061 "tracker-turtle-reader.c"
	}
}

const gchar*
tracker_turtle_reader_get_predicate (TrackerTurtleReader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->_predicate;
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp0_;
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 4078 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_set_predicate (TrackerTurtleReader* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	old_value = tracker_turtle_reader_get_predicate (self);
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4092 "tracker-turtle-reader.c"
		gchar* _tmp0_;
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = g_strdup (value);
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (self->priv->_predicate);
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->_predicate = _tmp0_;
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_object_notify_by_pspec ((GObject *) self, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_PREDICATE_PROPERTY]);
#line 4102 "tracker-turtle-reader.c"
	}
}

const gchar*
tracker_turtle_reader_get_object (TrackerTurtleReader* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	_tmp0_ = self->priv->_object;
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = _tmp0_;
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 4119 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_set_object (TrackerTurtleReader* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	old_value = tracker_turtle_reader_get_object (self);
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4133 "tracker-turtle-reader.c"
		gchar* _tmp0_;
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
		_tmp0_ = g_strdup (value);
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
		_g_free0 (self->priv->_object);
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->_object = _tmp0_;
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_object_notify_by_pspec ((GObject *) self, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_OBJECT_PROPERTY]);
#line 4143 "tracker-turtle-reader.c"
	}
}

gboolean
tracker_turtle_reader_get_object_is_uri (TrackerTurtleReader* self)
{
	gboolean result;
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
	result = self->priv->_object_is_uri;
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
	return result;
#line 4157 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_set_object_is_uri (TrackerTurtleReader* self,
                                         gboolean value)
{
	gboolean old_value;
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
	old_value = tracker_turtle_reader_get_object_is_uri (self);
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
	if (old_value != value) {
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
		self->priv->_object_is_uri = value;
#line 57 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_object_notify_by_pspec ((GObject *) self, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_OBJECT_IS_URI_PROPERTY]);
#line 4175 "tracker-turtle-reader.c"
	}
}

static TrackerTurtleReaderTokenInfo*
tracker_turtle_reader_token_info_dup (const TrackerTurtleReaderTokenInfo* self)
{
	TrackerTurtleReaderTokenInfo* dup;
#line 35 "../src/libtracker-data/tracker-turtle-reader.vala"
	dup = g_new0 (TrackerTurtleReaderTokenInfo, 1);
#line 35 "../src/libtracker-data/tracker-turtle-reader.vala"
	memcpy (dup, self, sizeof (TrackerTurtleReaderTokenInfo));
#line 35 "../src/libtracker-data/tracker-turtle-reader.vala"
	return dup;
#line 4189 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_token_info_free (TrackerTurtleReaderTokenInfo* self)
{
#line 35 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_free (self);
#line 4197 "tracker-turtle-reader.c"
}

static GType
tracker_turtle_reader_token_info_get_type_once (void)
{
	GType tracker_turtle_reader_token_info_type_id;
	tracker_turtle_reader_token_info_type_id = g_boxed_type_register_static ("TrackerTurtleReaderTokenInfo", (GBoxedCopyFunc) tracker_turtle_reader_token_info_dup, (GBoxedFreeFunc) tracker_turtle_reader_token_info_free);
	return tracker_turtle_reader_token_info_type_id;
}

static GType
tracker_turtle_reader_token_info_get_type (void)
{
	static volatile gsize tracker_turtle_reader_token_info_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_turtle_reader_token_info_type_id__volatile)) {
		GType tracker_turtle_reader_token_info_type_id;
		tracker_turtle_reader_token_info_type_id = tracker_turtle_reader_token_info_get_type_once ();
		g_once_init_leave (&tracker_turtle_reader_token_info_type_id__volatile, tracker_turtle_reader_token_info_type_id);
	}
	return tracker_turtle_reader_token_info_type_id__volatile;
}

static void
tracker_turtle_reader_class_init (TrackerTurtleReaderClass * klass,
                                  gpointer klass_data)
{
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	tracker_turtle_reader_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_type_class_adjust_private_offset (klass, &TrackerTurtleReader_private_offset);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tracker_turtle_reader_get_property;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tracker_turtle_reader_set_property;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	G_OBJECT_CLASS (klass)->finalize = tracker_turtle_reader_finalize;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_TURTLE_READER_GRAPH_PROPERTY, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_GRAPH_PROPERTY] = g_param_spec_string ("graph", "graph", "graph", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_TURTLE_READER_SUBJECT_PROPERTY, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_SUBJECT_PROPERTY] = g_param_spec_string ("subject", "subject", "subject", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_TURTLE_READER_PREDICATE_PROPERTY, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_PREDICATE_PROPERTY] = g_param_spec_string ("predicate", "predicate", "predicate", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_TURTLE_READER_OBJECT_PROPERTY, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_OBJECT_PROPERTY] = g_param_spec_string ("object", "object", "object", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_TURTLE_READER_OBJECT_IS_URI_PROPERTY, tracker_turtle_reader_properties[TRACKER_TURTLE_READER_OBJECT_IS_URI_PROPERTY] = g_param_spec_boolean ("object-is-uri", "object-is-uri", "object-is-uri", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4244 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_instance_init (TrackerTurtleReader * self,
                                     gpointer klass)
{
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv = tracker_turtle_reader_get_instance_private (self);
#line 64 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->bnodeid = 0;
#line 4255 "tracker-turtle-reader.c"
}

static void
tracker_turtle_reader_finalize (GObject * obj)
{
	TrackerTurtleReader * self;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TRACKER_TYPE_TURTLE_READER, TrackerTurtleReader);
#line 23 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_object_unref0 (self->priv->scanner);
#line 26 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->tokens = (g_free (self->priv->tokens), NULL);
#line 52 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (self->priv->_graph);
#line 54 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (self->priv->_subject);
#line 55 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (self->priv->_predicate);
#line 56 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_free0 (self->priv->_object);
#line 59 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_hash_table_unref0 (self->priv->prefix_map);
#line 61 "../src/libtracker-data/tracker-turtle-reader.vala"
	(self->priv->subject_stack == NULL) ? NULL : (self->priv->subject_stack = (_g_queue_free__g_free0_ (self->priv->subject_stack), NULL));
#line 62 "../src/libtracker-data/tracker-turtle-reader.vala"
	(self->priv->predicate_stack == NULL) ? NULL : (self->priv->predicate_stack = (_g_queue_free__g_free0_ (self->priv->predicate_stack), NULL));
#line 66 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->base_uuid = (g_free (self->priv->base_uuid), NULL);
#line 68 "../src/libtracker-data/tracker-turtle-reader.vala"
	_g_mapped_file_unref0 (self->priv->mapped_file);
#line 69 "../src/libtracker-data/tracker-turtle-reader.vala"
	self->priv->buffer = (g_free (self->priv->buffer), NULL);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	G_OBJECT_CLASS (tracker_turtle_reader_parent_class)->finalize (obj);
#line 4290 "tracker-turtle-reader.c"
}

static GType
tracker_turtle_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrackerTurtleReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tracker_turtle_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrackerTurtleReader), 0, (GInstanceInitFunc) tracker_turtle_reader_instance_init, NULL };
	GType tracker_turtle_reader_type_id;
	tracker_turtle_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "TrackerTurtleReader", &g_define_type_info, 0);
	TrackerTurtleReader_private_offset = g_type_add_instance_private (tracker_turtle_reader_type_id, sizeof (TrackerTurtleReaderPrivate));
	return tracker_turtle_reader_type_id;
}

GType
tracker_turtle_reader_get_type (void)
{
	static volatile gsize tracker_turtle_reader_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_turtle_reader_type_id__volatile)) {
		GType tracker_turtle_reader_type_id;
		tracker_turtle_reader_type_id = tracker_turtle_reader_get_type_once ();
		g_once_init_leave (&tracker_turtle_reader_type_id__volatile, tracker_turtle_reader_type_id);
	}
	return tracker_turtle_reader_type_id__volatile;
}

static void
_vala_tracker_turtle_reader_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	TrackerTurtleReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRACKER_TYPE_TURTLE_READER, TrackerTurtleReader);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	switch (property_id) {
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_GRAPH_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_value_set_string (value, tracker_turtle_reader_get_graph (self));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_SUBJECT_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_value_set_string (value, tracker_turtle_reader_get_subject (self));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_PREDICATE_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_value_set_string (value, tracker_turtle_reader_get_predicate (self));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_OBJECT_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_value_set_string (value, tracker_turtle_reader_get_object (self));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_OBJECT_IS_URI_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		g_value_set_boolean (value, tracker_turtle_reader_get_object_is_uri (self));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 4355 "tracker-turtle-reader.c"
		default:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 4361 "tracker-turtle-reader.c"
	}
}

static void
_vala_tracker_turtle_reader_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	TrackerTurtleReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TRACKER_TYPE_TURTLE_READER, TrackerTurtleReader);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
	switch (property_id) {
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_GRAPH_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_turtle_reader_set_graph (self, g_value_get_string (value));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_SUBJECT_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_turtle_reader_set_subject (self, g_value_get_string (value));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_PREDICATE_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_turtle_reader_set_predicate (self, g_value_get_string (value));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_OBJECT_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_turtle_reader_set_object (self, g_value_get_string (value));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		case TRACKER_TURTLE_READER_OBJECT_IS_URI_PROPERTY:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		tracker_turtle_reader_set_object_is_uri (self, g_value_get_boolean (value));
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 4405 "tracker-turtle-reader.c"
		default:
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/libtracker-data/tracker-turtle-reader.vala"
		break;
#line 4411 "tracker-turtle-reader.c"
	}
}

